%% create Figure 4
clear all %#ok<CLALL>
RR=[-0.99 -0.95:0.05:0.95 0.99]; % vector of within-pair Pearson correlations
DD=[0 2];
reps=100000;
[p1,p2]=deal(NaN(length(DD),length(RR),reps));
for i3=1:length(DD)
    for i2=1:length(RR)
        disp([i3 i2]) % show counter
        for i=1:reps
            N=3; M=3; D=DD(i3); r=RR(i2);
            X=randn(N,1)+D; % sample with population mean = D
            X2=r*(X-D)+sqrt((1-r^2))*randn(M,1); % sample with population mean = 0
            V=tiedrank([X;X2]); % rank transformation of combined sample
            [~,p1(i3,i2,i)]=ttest(X,X2); % paired t-test
            [~,p2(i3,i2,i)]=ttest(V(1:N),V(N+1:end)); % paired t-test after rank transformation (ttestR)
        end
    end
end

figure;hold on % create Figure 4
plot(RR, mean(squeeze(p1(1,:,:))'<.05)','k-o','Linewidth',3,'MarkerSize',15)
plot(RR, mean(squeeze(p2(1,:,:))'<.05)','k-s','Linewidth',3,'MarkerSize',15)
plot(RR, mean(squeeze(p1(2,:,:))'<.05)','r-o','Linewidth',3,'MarkerSize',15)
plot(RR, mean(squeeze(p2(2,:,:))'<.05)','r-s','Linewidth',3,'MarkerSize',15)
xlabel('\it{r}\rm','FontSize',32,'FontName','Arial')
ylabel('Type I error rate / Statistical power at \it{D}\rm = 2','FontSize',32,'FontName','Arial')
legend('Type I error rate \it{t}\rm-test','Type I error rate \it{t}\rm-testR','1-Type II error rate \it{t}\rm-test','1-Type II error rate \it{t}\rm-testR','location','northwest')
h=findobj('FontName','Helvetica'); set(h,'FontName','Arial','fontsize',32)