clear all;close all;clc %#ok<CLALL>
v=1;
mm=logspace(log10(0.1), log10(100),20); 
CC=[3 3 1 2; % 8. equal sample size, equal variance, lognormal distribution, D = 0
    3 3 1 2]; % 8. equal sample size, equal variance, lognormal distribution, D = 2
DD=[0 2];
reps=100000;
[p2,p3,p4]=deal(NaN(size(CC,1),length(DD),reps));

for i3=1:length(DD)
    for i2=1:length(mm)
        disp([i3 i2])
        m=mm(i2);
        mu = log((m^2)/sqrt(v+m^2));sigma = sqrt(log(v/(m^2)+1)); % parameters for lognormal distribution
        for i=1:reps
            N=CC(i3,1);
            M=CC(i3,2);
            R=CC(i3,3);
            if CC(i3,4)==1 % normal distribution
               else  % lognormal distribution
                if CC(i3,4)==2
                    X=(lognrnd(mu,sigma,N,1)-m)/R+DD(i3);
                elseif CC(i3,4)==-2
                    X=-(lognrnd(mu,sigma,N,1)-m)/R+DD(i3);
                end
                X2=(lognrnd(mu,sigma,M,1)-m)*R;
            end
            V=tiedrank([X;X2]);     % ranking of combined sample
            C=[X;X2];
            [~,p2(i3,i2,i)]=ttest2(X,X2); % two sample t test
            [~,p3(i3,i2,i)]=ttest2(V(1:N),V(N+1:end));  % two sample t test after rank transformation
            [~,p4(i3,i2,i)]=ttest2(X,X2,[],[],'unequal');  % two-sample t test using unequal variances option
       end
    end
end
%%
S=NaN(length(mm),1);
for i=1:length(mm)
    v=1;    
    m=mm(i);
    mu = log((m^2)/sqrt(v+m^2));sigma = sqrt(log(v/(m^2)+1)); % parameters for lognormal distribution
    S(i) = sqrt(exp(sigma^2)-1)*(2+exp(sigma^2));
end
%%
close all
figure
semilogx(S,mean(squeeze(p3(1,:,:))'<.05)','r-^','Linewidth',3);hold on
semilogx(S,mean(squeeze(p2(1,:,:))'<.05)','k-o','Linewidth',3)
semilogx(S,mean(squeeze(p4(1,:,:))'<.05)','g-s','Linewidth',3)
xlabel('Skewness','FontSize',32,'FontName','Arial')
ylabel('Type I error rate','FontSize',32,'FontName','Arial')
legend('\it{t}\rm-testR (2 sample)','\it{t}\rm-test (2 sample)','Welch test (2 sample)','location','northeast')
h=findobj('FontName','Helvetica'); set(h,'FontName','Arial','fontsize',32)

figure
semilogx(S,mean(squeeze(p3(2,:,:))'<.05)','r-^','Linewidth',3);hold on
semilogx(S,mean(squeeze(p2(2,:,:))'<.05)','k-o','Linewidth',3)
semilogx(S,mean(squeeze(p4(2,:,:))'<.05)','g-s','Linewidth',3)
xlabel('Skewness','FontSize',32,'FontName','Arial')
ylabel('Statistical power at \it{D}\rm = 2','FontSize',32,'FontName','Arial')
legend('\it{t}\rm-testR (2 sample)','\it{t}\rm-test (2 sample)','Welch test (2 sample)','location','northwest')
h=findobj('FontName','Helvetica'); set(h,'FontName','Arial','fontsize',32)
