close all;clear all;clc %#ok<CLALL>
m = 0.8;v = 1;mu = log((m^2)/sqrt(v+m^2));sigma = sqrt(log(v/(m^2)+1)); % parameters for lognormal distribution
DD=[0:1:10 15 20 40];
%% CC matrix consists of 1. Sample size N, 2. Sample size M., 3. Ratio of variances, 4. Distribution (1 = normal, 2 = lognormal)
CC=[2 2 1 1     % 1. equal sample size, equal variance
    3 3 1 1     % 2. equal sample size, equal variance
    5 5 1 1     % 3. equal sample size, equal variance
    2 5 1 1     % 4. unequal sample size, equal variance
    3 3 2 1     % 5. equal sample size, unequal variance
    2 5 2 1     % 6. unequal sample size, unequal variance
    5 2 2 1     % 7. unequal sample size, unequal variance
    3 3 1 2     % 8. equal sample size, equal variance, lognormal distribution
    15 15 1 2]; % 9. equal sample size, equal variance, lognormal distribution ("large sample" verification)
reps=100000;
[p1,p2,p3,p4]=deal(NaN(size(CC,1),length(DD),reps));
for i3=1:size(CC,1)
    for i2=1:length(DD)
        disp([i3 i2]) % display counter
        for i=1:reps
            N=CC(i3,1);
            M=CC(i3,2);
            R=CC(i3,3);
            if CC(i3,4)==1 % normal distribution
                X=randn(N,1)/R+DD(i2); % sample with population mean = D
                X2=randn(M,1)*R; % sample with population mean = 0
            else % lognormal distribution
                X=(lognrnd(mu,sigma,N,1)-m)/R+DD(i2); % sample with population mean = D
                X2=(lognrnd(mu,sigma,M,1)-m)*R; % sample with population mean = 0
            end
            V=tiedrank([X;X2]); % rank transformation of concatenated vectors
            [~,p1(i3,i2,i)]=ttest(X); % one sample t-test with respect to 0
            [~,p2(i3,i2,i)]=ttest2(X,X2); % two sample t-test
            [~,p3(i3,i2,i)]=ttest2(V(1:N),V(N+1:end)); % two sample t-test after rank transformation (t-testR)
            [~,p4(i3,i2,i)]=ttest2(X,X2,[],[],'unequal'); % two-sample t-test using unequal variances option (Welch test)
        end
    end
end
%% display results of Tables 1-4
for i3=1:size(CC,1)
    disp(CC(i3,:,:))
    disp([DD' mean(squeeze(p1(i3,:,:))'<.05)' mean(squeeze(p2(i3,:,:))'<.05)'  mean(squeeze(p3(i3,:,:))'<.05)' mean(squeeze(p4(i3,:,:))'<.05)'])
end